%define service ntpd
%define site fermi
%define firewallservice %{service}.%{site}
#
Summary: This will configure the ntpd config files for Fermilab. 
Name: zz_ntp_configure
Version: 4.2.6
Release: 3
License: GPL
Group: Fermi
URL: http://www.fnal.gov/cd/UNIX/linux/
Vendor: Fermilab
Packager: Troy Dawson
requires: ntp, ntpdate, perl
obsoletes: zz_xntp3_change
BuildRoot: %{_tmppath}/%{name}-%{version}
Source1: %{firewallservice}
BuildArch: noarch

%description

This package configures the ntp time daemon correctly for use at Fermilab.  It
sets the initial time from the nameservers (131.225.8.120 and 131.225.17.150) 
and configures ntpd to listen to time broadcasts from the local router of the
subdomain that the machine is on.  This package also adds servers 131.225.8.120
and 131.225.17.150 secondary and tertiary time servers.

The /etc/ntp.conf  will be saved with a suffix of .rpmsave.

%install
mkdir -p $RPM_BUILD_ROOT/etc/sysconfig/
cp -f %{SOURCE1} $RPM_BUILD_ROOT/etc/sysconfig/
chmod 755 $RPM_BUILD_ROOT/etc/sysconfig/*

%files
/etc/sysconfig/%{firewallservice}

%triggerin -- ntp
#
# This modifies /etc/init.d/%{service} to poke holes in the firewall for it
#
if [ "$(grep /etc/sysconfig/%{firewallservice} /etc/init.d/%{service})" = "" ] ; then
  cat /etc/init.d/%{service} | sed 's:\(start().*\):\1\nif \[ -x /etc/sysconfig/%{firewallservice} \] ; then \n/etc/sysconfig/%{firewallservice} start\nfi:' > /etc/init.d/%{service}.tmp
  mv -f /etc/init.d/%{service}.tmp /etc/init.d/%{service}
  cat /etc/init.d/%{service} | sed 's:\(stop().*\):\1\nif \[ -x /etc/sysconfig/%{firewallservice} \] ; then \n/etc/sysconfig/%{firewallservice} stop\nfi:' > /etc/init.d/%{service}.tmp
  mv -f /etc/init.d/%{service}.tmp /etc/init.d/%{service}
  chmod 755 /etc/init.d/%{service}
fi
#
# This modifies /etc/ntp.conf
#
if [ `grep "restrict 131.225.0.0 mask 255.255.0.0 nomodify" /etc/ntp.conf | wc -l` -eq 0 ]; then
  #
  # copy the original off first
  #
	if [ -f /etc/ntp.conf.rpmsave ]; then
        mv /etc/ntp.conf.rpmsave /etc/ntp.conf.rpmsave.o
	fi
	cp /etc/ntp.conf /etc/ntp.conf.rpmsave.$$

  #
  #now actually do the modifications
  #
	perl -pe 's/(^enable\s+bclient)//;' -i /etc/ntp.conf 
	perl -pe 's/^authenticate\s+(.*)/authenticate no/;' -i /etc/ntp.conf
	perl -pe 's/^broadcastclient/#broadcastclient/;' -i /etc/ntp.conf
	perl -pe 's/^server\s+([0-9]+\.rhel\.pool\.ntp\.org)/#server \1/;' -i /etc/ntp.conf
        perl -pe 's/^fudge/#fudge/;' -i /etc/ntp.conf
	perl -pe 's/^multicastclient/#multicastclient/;' -i /etc/ntp.conf
	echo "restrict 131.225.0.0 mask 255.255.0.0 nomodify noquery" >> /etc/ntp.conf
	echo "server 131.225.8.120" >> /etc/ntp.conf
	echo "server 131.225.17.150" >> /etc/ntp.conf
	echo "broadcastclient" >> /etc/ntp.conf

else
	cp /etc/ntp.conf /etc/ntp.conf.rpmsave.$$
	perl -pe 's/(^enable bclient)//;' -i /etc/ntp.conf 
fi

#
# This makes sure the daemon is added to the runlevels 3, 4, and 5
# and restarts the service

/sbin/chkconfig --add ntpd
/sbin/chkconfig --levels 345 ntpd on
/etc/init.d/ntpd restart > /dev/null 2>&1

%triggerin -- ntpdate
#
# This correctly configures /etc/ntp/step-tickers
#

if [ -s /etc/ntp/step-tickers ]; then
	if [ -f /etc/ntp/step-tickers.rpmsave ]; then
		mv /etc/ntp/step-tickers.rpmsave /etc/ntp/step-tickers.rpmsave.$$
	else
		cp /etc/ntp/step-tickers /etc/ntp/step-tickers.rpmsave
	fi
fi
echo "131.225.8.120 131.225.17.150" > /etc/ntp/step-tickers

%triggerin -- firstboot
#
# This makes it so that you don't get asked about ntp on the firstboot
# 
if [ -s /usr/share/firstboot/modules/date.py ]; then
	rm -f /usr/share/firstboot/modules/date.py*
fi

%changelog
* Thu Jun 16 2011 Connie Sieh <csieh@fnal.gov> 4.2.6-3
- Modified ntpd-fermi code from "RH-Firewall-1-INPUT" to "INPUT" as TUV
  Does not use "RH-Firewall-1-INPUT" anymore. 

* Thu May 26 2011 Tyler Parsons <tparsons@fnal.gov> 4.2.6-2
- added secondary and tertiary time servers to ntp.conf (131.225.17.150 and 131.225.8.120)
- changed references to servers from (131.225.8.200 and 131.225.17.200) to (131.225.17.150 and 131.225.8.120)
 
* Mon Aug 16 2010 Troy Dawson <dawson@fnal.gov> 4.2.6-1
- added ntpdate to the requirements
- Changed the step-tickers section to trigger on ntpdate
- Removed the change that added -A to /etc/sysconfig/ntpd

* Mon Jun 14 2010 Troy Dawson <dawson@fnal.gov> 4.2.0-9
- Added noquery to the restrict line

